package com.wechi.adweb.bridge.google.analytics.dto.report;

import com.google.analytics.data.v1beta.Row;

import lombok.Builder;
import lombok.Data;

import java.util.List;

/**
 * @author wfansh
 */
@Data
@Builder
public class CountryChartRowDTO implements GAReportRowDTO {
    private String country;
    private int num;

    public static List<CountryChartRowDTO> fromReportRows(
            List<Row> reportRows, GAReportRequestDTO reportRequest) {
        int indexCountry = reportRequest.getDimensions().indexOf(ReportConstant.DIMENSION_COUNTRY);

        return reportRows.stream()
                .map(
                        row ->
                                CountryChartRowDTO.builder()
                                        .country(row.getDimensionValues(indexCountry).getValue())
                                        // The first metric value.
                                        .num(Integer.parseInt(row.getMetricValues(0).getValue()))
                                        .build())
                .toList();
    }
}
