package com.wechi.adweb.bridge.google.analytics.dto.report;

import static com.wechi.adweb.bridge.google.analytics.dto.report.ReportConstant.*;

import lombok.Getter;

import java.util.List;

/**
 * @author wfansh
 */
@Getter
public enum ReportType {
    ADWEB3_COUNTRY_CHART(List.of(METRIC_TOTAL_USERS), List.of(DIMENSION_COUNTRY));

    private ReportType(List<String> defaultMetrics, List<String> defaultDimensions) {
        this.defaultMetrics = defaultMetrics;
        this.defaultDimensions = defaultDimensions;
        this.defaultOrderBy = null;
        this.defaultOrderByType = null;
        this.defaultOrderByDesc = false;
    }

    private ReportType(
            List<String> defaultMetrics,
            List<String> defaultDimensions,
            String defaultOrderBy,
            GAReportRequestDTO.OrderByType defaultOrderByType,
            boolean defaultOrderByDesc) {
        this.defaultMetrics = defaultMetrics;
        this.defaultDimensions = defaultDimensions;
        this.defaultOrderBy = defaultOrderBy;
        this.defaultOrderByType = defaultOrderByType;
        this.defaultOrderByDesc = defaultOrderByDesc;
    }

    private List<String> defaultMetrics;
    private List<String> defaultDimensions;
    private String defaultOrderBy;
    private GAReportRequestDTO.OrderByType defaultOrderByType;
    private boolean defaultOrderByDesc;
}
